# -*- coding: utf-8 -*-
"""Classification_chiffres_MNIST.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1PfCocp0cuWmh1oiAiDSjj4csyEINDu6Y

# Classification de chiffres par réseau de neurones

TP proposé par **Simon Kirchhofer**. Contact : simon.kirchhofer@ens-rennes.fr

<img src="https://drive.google.com/uc?id=1NcyMHqvLVIUD2sugrCzJBD_HA2NLWn6h" width="100">

Dans les années 1990, le crédit mutuel de Bretagne a mis en place une solution de lecture automatique des écritures manuscrites sur les chèques. Ils ont utilisé un algorithme de réseau de neurones.
Étudions comment identifier des chiffres manuscrits.

## Importation des bibliothèques
"""

# Commented out IPython magic to ensure Python compatibility.
# %pip install scikit-learn==1.0.2
# %pip install tensorflow==2.8.2
# %pip install matplotlib==3.2.2

# TensorFlow and tf.keras
import tensorflow as tf
from tensorflow import keras
from sklearn.metrics import ConfusionMatrixDisplay
from sklearn.metrics import confusion_matrix

# Helper libraries
import numpy as np
import matplotlib.pyplot as plt

"""Importation des données


La séparation des données d'apprentissage et de test est réalisée à l'importation
"""

mnist = tf.keras.datasets.mnist # La base de données MNIST contient des paires de données.
#Il s'agit d'images de chiffres manuscrits associées un label (chiffre entre 0 et 9).

(train_images, train_labels), (test_images, test_labels) = mnist.load_data()

"""##Préparation des données

-----
<div class="alert alert-block alert-info"> 

 <b>Questions</b>
 
Que représente les dimensions des données en entrée ? En sortie ?

Combien d'images sont contenu dans la base de test ? d'apprentissage ?

</div> 

--------
"""

print('dimensions des données d\'apprentissage en entrée : ' + str(train_images.shape))
print('dimensions des données d\'apprentissage en sortie : ' + str(train_labels.shape))
print('dimensions des données de test en entrée : ' + str(test_images.shape))
print('dimensions des données de test en sortie : ' + str(test_labels.shape))

"""--------
<div class="alert alert-block alert-info"> 

 <b>Réponse</b>

'train_images' est un tenseur de la forme (60000, 28, 28) . Il s'agit d'un lot de 60000 images de forme 28x28 pixels.
Il y a 60k images dans la base d'apprentissage et 10k dans la base de test


'train_labels' est un tenseur de la forme (60000, 1) . Il s'agit d'un lot de 60000 label (valeur de 0 à 9).

 </div>

 ---------

##Visualisation de la base de données
--------
<div class="alert alert-block alert-info"> 

 <b>Question</b>

À quoi correspond le maximum de 'train_images' ?
    
 </div>

 ---------
"""

plt.figure()
plt.imshow(train_images[0]) # Affichae de la première image de l'ensemble d'apprentissage
plt.colorbar()
plt.grid(False)
plt.title('1ère image de la base d\'apprentissage')
plt.show()

print('valeur max de \'train_images\' = ' + str(np.max(train_images)))

"""--------
<div class="alert alert-block alert-info"> 

 <b>Réponse</b>

Les valeurs dans 'train_images' correspondent aux valeurs des pixels. Les valeurs encodées sur 8 bits, donc les valeurs sont comprisent entre 0 et 255.
    
 </div>

 ---------


"""

print('Les labels d\'apprentissage sont : ' + str(train_labels)) #Affichage des labels de la base d'apprentissage

"""
Les réseaux de neurones fonctionne mieux avec des valeurs comprises entre 0 et 1. Nous normalisons les images pour que les valeurs des pixels soient comprises entre 0 et 1."""

train_images = train_images / 255.0
test_images = test_images / 255.0

"""Affichage de quelques éléments de la base de données"""

plt.figure(figsize=(10,10))
for i in range(25):
    plt.subplot(5,5,i+1)
    plt.xticks([])
    plt.yticks([])
    plt.grid(False)
    plt.imshow(train_images[i], cmap=plt.cm.binary)
    plt.xlabel('label =' + str(train_labels[i]))
plt.show()

"""##Choix de l'architecture du réseau de neurones

### Réseau dense (fully connected) :


La première couche de ce réseau, tf.keras.layers.Flatten , transforme le format des images d'un tableau bidimensionnel (de 28 par 28 pixels) en un tableau unidimensionnel (de 28 * 28 = 784 pixels). Considérez ce calque comme désempilant des rangées de pixels dans l'image et en les alignant. Cette couche n'a aucun paramètre à apprendre ; il ne fait que reformater les données.

Une fois les pixels aplatis, le réseau se compose d'une séquence de deux couches tf.keras.layers.Dense . Ce sont des couches neuronales densément connectées ou entièrement connectées. La première couche Dense compte 64 nœuds (ou neurones). La deuxième couche renvoie un tableau logits d'une longueur de 10. Enfin, la couche Softmax renvoie une probabilité indiquant que l'image actuelle appartient à l'une des 10 classes.
"""

# Reseau dense

model = tf.keras.Sequential([
    tf.keras.layers.Flatten(input_shape=(28, 28)),
    tf.keras.layers.Dense(32, activation='relu'),
    tf.keras.layers.Dense(10),
    tf.keras.layers.Softmax()
])

"""### Cas d'un réseau convolutionnel (CNN)

Voici un réseau convolutif à 6 couches. Il permet de réduire la dimension d'entrée (taille 28x28) tout en calculant des caractéristiques afin de réussir la classification.

Pour plus d'explications sur les réseaux convolutifs : 

https://towardsdatascience.com/a-comprehensive-guide-to-convolutional-neural-networks-the-eli5-way-3bd2b1164a53
"""

# Réseau convolutif
# Il n'est pas utilisé par la suite. Si vous voulez l'utiliser, remplacer "model_2" par "model"

model_2 = tf.keras.Sequential([
    tf.keras.layers.Conv2D(4,5,input_shape=(28, 28,1)), # 4 convolutions 2 dimensions avec un noyau de 5x5
    tf.keras.layers.MaxPooling2D(pool_size=(2, 2)), # Avec un MaxPooling de taille (2,2), on divise par 2*2=4 le nombre de neurones sur la couche suivante
    tf.keras.layers.Conv2D(4,5), # 4 convolutions 2 dimensions avec un noyau de 5x5
    tf.keras.layers.Flatten(), # On passe de 2 dimension à 1 dimension. Notre matrice devient un vecteur
    tf.keras.layers.Dense(10), #couche dense en sortie
    tf.keras.layers.Softmax() # La couche softmax nous permet de passer à des probabilités
])

model.compile(optimizer=keras.optimizers.Adam(learning_rate=0.0005), # optimiseur Adam avec un le choix du learning rate
              loss=tf.keras.losses.SparseCategoricalCrossentropy(), # choix du loss
              metrics=['accuracy']) #choix de la métrique

"""
--------
<div class="alert alert-block alert-info"> 

 <b>Question</b>

À quoi correspond les paramètres du modèle ?
    
 </div>

 ---------"""

model.summary()

"""--------
<div class="alert alert-block alert-info"> 

 <b>Réponse</b>

Les paramètres sont les poids et les biais de chaque neurone
    
 </div>

 ---------

##Apprentissage

Début de l'apprentissage. Il faut spécifier le pourcentage de données pour la validation (ici 20%) et le nombre de fois que le réseau va parcourir toutes les données (nombre d'epoch)
"""

# le modèle est entrainé sur la base d'apprentissage. Les deux premiers paramètre de model.fit sont :
# x, y les entrées et sorties du modèle
# validation_split=0.2 -> 20% de la base d'apprentissage est utilisée pour la validation
# epochs=40 -> Le reseau fait une propagation + rétropropagation sur la totalité de la base d'apprentissage 40 fois
history = model.fit(train_images, train_labels,validation_split=0.2, epochs=40)

"""##Affichage de l'évolution du coût et de la précision pendant l'apprentissage
--------
<div class="alert alert-block alert-info"> 

 <b>Question</b>

Que peut on en déduire ? L'apprentissage est il acceptable ?
    
 </div>

 ---------

"""

acc = history.history['accuracy']
val_acc = history.history['val_accuracy']

loss = history.history['loss']
val_loss = history.history['val_loss']

epochs_range = range(len(history.history['loss']))

plt.figure(figsize=(8, 8))
plt.subplot(1, 2, 1)
plt.plot(epochs_range, acc, label='Training Accuracy')
plt.plot(epochs_range, val_acc, label='Validation Accuracy')
plt.legend(loc='lower right')
plt.title('Training and Validation Accuracy')

plt.subplot(1, 2, 2)
plt.plot(epochs_range, loss, label='Training Loss')
plt.plot(epochs_range, val_loss, label='Validation Loss')
plt.legend(loc='upper right')
plt.title('Training and Validation Loss')
plt.show()

"""--------
<div class="alert alert-block alert-info"> 

 <b>Réponse</b>

L'apprentissage a convergé. À la fin de l'apprentissage, l'exactitude (Accuracy) est presque de 100% sur les données d'apprentissage et 97% sur les données de validation. On voit apparaitre du sur-apprentissage. 

Comment lutter contre le sur-apprentissage ?

Par ordre d'importance : plus de données, modification des hyperparamètres, early stopping.
    
 </div>

 ---------

## Évaluation de la base de test
"""

test_loss, test_acc = model.evaluate(test_images,  test_labels, verbose=2)

print('\nTest accuracy:', test_acc)

"""L'exactitude sur la base de test permet de valider le fonctionnement du réseau sur des données qu'elle n'a **absolument** jamais vu. 

Ici, la précision sur la base de test est de 96.5% (suffisant ou pas, en accord avec le cahier des charges du système).

## Prédictions

Maintenant que l'apprentissage est terminé, nous pouvons exploiter le réseau pour classifier des images. Vérifions pour une image de la base de test
"""

img=96
plt.figure()
plt.imshow(test_images[img], cmap=plt.cm.binary)
plt.title('Un image de la base de test')
plt.show()

"""Quel est le chiffre prédit par le réseau de neurone pour la première image de la base de test?"""

predictions = model.predict(test_images)  # la fonction prédict est une inférence. Elle prend en entrée une (ou plusieurs) image 
                                          # et sort le label prédit par le réseau entrainé
                                          
#On affiche la prediction de la première image de 'test_images' :
print('la prediction de l\'image ' + str(img) + ' de la base de test est : ' + '\n' + str(np.round(predictions[96],2)))

"""Une prédiction est un tableau de 10 nombres. Ils représentent la "confiance" du modèle que l'image correspond à chacun des 10 chiffres. Vous pouvez voir quelle étiquette a la valeur de confiance la plus élevée :"""

max_pred = np.argmax(predictions[img])
print('le chiffre prédit est : ' + str(max_pred))

#Juste des fonctions d'affichage.
def plot_image(i, predictions_array, true_label, img):
  true_label, img = true_label[i], img[i]
  plt.grid(False)
  plt.xticks([])
  plt.yticks([])

  plt.imshow(img, cmap=plt.cm.binary)

  predicted_label = np.argmax(predictions_array)
  if predicted_label == true_label:
    color = 'blue'
  else:
    color = 'red'

  plt.xlabel("Prédiction : {} à {:2.0f}% (Vrai : {})".format(str(predicted_label),
                                100*np.max(predictions_array),
                                str(true_label),
                                color=color))

def plot_value_array(i, predictions_array, true_label):
  true_label = true_label[i]
  plt.grid(False)
  plt.xticks(range(10))
  plt.yticks([])
  plt.xlabel('repartition de probabilités')
  thisplot = plt.bar(range(10), predictions_array, color="#777777")
  plt.ylim([0, 1])
  predicted_label = np.argmax(predictions_array)

  thisplot[predicted_label].set_color('red')
  thisplot[true_label].set_color('blue')

"""Regardons la 0ème image, les prédictions et le tableau de prédiction. Les étiquettes de prédiction correctes sont bleues et les étiquettes de prédiction incorrectes sont rouges. Le nombre donne le pourcentage (sur 100) pour l'étiquette prédite."""

plt.figure(figsize=(6,3))
plt.subplot(1,2,1)
plot_image(img, predictions[img], test_labels, test_images)
plt.subplot(1,2,2)
plot_value_array(img, predictions[img],  test_labels)
plt.show()

# Affichage des 15 première images de la base de test ainsi que les prédictions
num_rows = 5
num_cols = 3
num_images = num_rows*num_cols
plt.figure(figsize=(2*2*num_cols, 2*num_rows))
for i in range(num_images):
  plt.subplot(num_rows, 2*num_cols, 2*i+1)
  plot_image(i, predictions[i], test_labels, test_images)
  plt.subplot(num_rows, 2*num_cols, 2*i+2)
  plot_value_array(i, predictions[i], test_labels)
plt.tight_layout()
plt.show()

"""Cherchons les images de la base de test avec une fausse prédiction"""

false_prediction = np.squeeze(np.where(np.argmax(predictions,axis=1)-test_labels!=0)) # On cherche les données pour lesquels la prediction est différent du vrai label
num_rows = 5
num_cols = 3
num_images = num_rows*num_cols
false_subsample = np.random.choice(false_prediction, size=num_images, replace=False)
plt.figure(figsize=(2*2*num_cols, 2*num_rows))
for i,false in enumerate(false_subsample):
  plt.subplot(num_rows, 2*num_cols, 2*i+1)
  plot_image(false, predictions[false], test_labels, test_images)
  plt.subplot(num_rows, 2*num_cols, 2*i+2)
  plot_value_array(false, predictions[false], test_labels)
plt.tight_layout()
plt.show()

"""La matrice de confusion nous permet de savoir quels sont les chiffres qui posent problème.
Les valeurs dans la diagonale représentent les bonnes prédictions.
Les valeurs hors diagonale représentent les erreurs de prédiction. Par exemple, la valeur de la dernière ligne et de la première colonne représente le nombre de 9 que le réseau a pris pour un 0.
"""

cm = confusion_matrix(test_labels,np.argmax(predictions,axis=1))

disp = ConfusionMatrixDisplay(confusion_matrix=cm)

disp.plot(cmap=plt.cm.Blues)
plt.show()